<template>
  <div>
    <h3 class="text-yellow-600 font-bold text-lg">
      Les étapes par jour
    </h3>
    <ul>
      <li>
        <div class="inline-block w-5/12 text-center mr-4">
          Jour
        </div>
        <div class="inline-block w-5/12 text-center">
          Nombre d'étapes
        </div>
        <div class="w-2/12 h-full bg-red-200 inline-block"></div>
      </li>
      <li :key="index" v-for="([day],index) in values.nbStepsByDay">
        <div v-if="index === 0" class="w-5/12 h-full inline-block mr-4">
          <p>Tous les jours</p>
        </div>
        <div v-if="index > 0" class="w-5/12 inline-block mr-4">
          <select v-model="values.nbStepsByDay[index][0]" class="appearance-none rounded-lg w-full py-3 border border-gray-300 placeholder-gray-300 text-gray-900 focus:outline-none focus:ring-yellow-500 focus:border-yellow-500 focus:z-10 sm:text-sm">
            <option :value="n" :key="n" v-for="n in getDays(day)">
              Jour {{n}}
            </option>
          </select>
        </div>
        <div class="w-5/12 inline-block">
          <input v-model="values.nbStepsByDay[index][1]" type="number" class="appearance-none rounded-lg w-full py-3 border border-gray-300 placeholder-gray-300 text-gray-900 focus:outline-none focus:ring-yellow-500 focus:border-yellow-500 focus:z-10 sm:text-sm" min="1" />
        </div>
        <font-awesome-icon
            v-if="index > 0"
            @click="deleteException(index)"
            icon="trash"
            class="cursor-pointer ml-5 hover:bg-gray-200 p-1 rounded-lg w-2/12"
            size="lg"
        />
      </li>
    </ul>
    <font-awesome-icon
        v-show="values.nbStepsByDay.length <= parseInt(values.nbDays)"
        icon="plus"
        class="cursor-pointer hover:bg-gray-200 p-1 rounded-lg"
        size="2x"
        @click="addException"
    />
    <p v-show="!isNaN(totalNbSteps)">{{totalNbSteps}} étapes au total</p>
    <ul class="errors">
      <li
          v-for="(error, index) in violations.nbStepsByDay"
          :key="index"
          class="text-red-600"
      >
        {{ error }}
      </li>
    </ul>
  </div>
</template>

<script>
export default {
  name: "NbStepsByDay",
  inject: ['values','violations'],
  computed: {
    totalNbSteps() {
      let allValue = null
      let totalNbSteps = 0;
      for (const [day,nbStep] of this.values.nbStepsByDay) {
        if (day !== "all")
          totalNbSteps += parseInt(nbStep)
        else
          allValue = parseInt(nbStep);
      }
      if (allValue)
        totalNbSteps += allValue * (parseInt(this.values.nbDays)-this.values.nbStepsByDay.length+1);
      return totalNbSteps;
    }
  },
  methods: {
    getDays(currentDay) {
      const days = [];
      for (let day=1;day<=parseInt(this.values.nbDays);day++)
        if (day === currentDay || !this.values.nbStepsByDay.some(([aDay]) => aDay === day))
          days.push(day);
      return days;
    },
    deleteException(index) {
      for (let i=1;i<this.values.nbStepsByDay.length;i++) {
        if (i === index) {
          this.values.nbStepsByDay.splice(i,1);
          break;
        }
      }
    },
    addException() {
      let newDay = null;
      for (let day=1;day<=parseInt(this.values.nbDays);day++)
        if (!this.values.nbStepsByDay.some(([aDay]) => aDay === day)) {
          newDay = day;
          break;
        }
      if (newDay === null) {
        alert("Vous ne pouvez plus ajouter d'exceptions");
        return;
      }
      this.values.nbStepsByDay.push([newDay,2]);
    }
  },
  watch: {
    "values.nbDays": function(newNbDays) {
      for (let i=1;i<this.values.nbStepsByDay.length;i++) {
        if (this.values.nbStepsByDay[i][0] > newNbDays) {
          this.values.nbStepsByDay.splice(i,1);
          break;
        }
      }
    }
  }
}
</script>

<style scoped>

</style>